/**
* Programa CorreccionTest.java
*
* Creado por: Mari Carmen Otero
* Fecha: Mayo 2002
*
**/

import java.io.*;

public class CorreccionTest
{
  public static void main(String[] args) throws IOException
  {
      //ficheros de entrada y de salida
      File           ficheroEntrada1  = new File("respuestas.txt");
      FileReader     leeFichero1      = new FileReader(ficheroEntrada1);
      BufferedReader lectorBuffer        = new BufferedReader(leeFichero1);

	  File               ficheroEntrada2     = new File("respCorrectas.datos");
      FileInputStream    flujoEntradaF2      = new FileInputStream(ficheroEntrada2);
      ObjectInputStream  flujoEntradaObjeto  = new ObjectInputStream(flujoEntradaF2);

      File              ficheroSalida       = new File("resultados.txt");
      FileOutputStream  flujoFicheroSalida  = new FileOutputStream(ficheroSalida);
      PrintWriter       flujoSalida         = new PrintWriter(flujoFicheroSalida);

      //variables relacionadas con los atributos
      //del fichero 'respuestas.txt'
      String numeroDNI, numeroTest, respTodas;
      float totalPuntos;
      char respCorrecta;

	  //Fichero de entrada 'respCorrectas.datos'
	  //
	  //Cargar el archivo anterior en un array de objetos RespuestasTest
	  RespuestasTest objetoResp;

	  RespuestasTest [] arrayResp = new RespuestasTest [4];

	  int i = 0;
	  boolean eof = false;

      while(!eof)
      {
           try
           {
              objetoResp = (RespuestasTest) flujoEntradaObjeto.readObject();
              arrayResp [i] = objetoResp;
              i++;
           }
           catch(EOFException e)
           {
               eof = true;
           }
           catch (ClassNotFoundException e)
           {
			   eof = true;
	       }
      }

      flujoEntradaObjeto.close();

      //Fichero de Entrada 'respuestas.txt'
      //
      //leer el String correspondiente al nombre del empleado
      numeroDNI = lectorBuffer.readLine();

      while(numeroDNI != null)
      {
          totalPuntos = 0.0f;

          numeroTest = lectorBuffer.readLine();
          int n = Integer.parseInt(numeroTest);

		  i = 0;
		  while ( arrayResp[i].leerNumero() != n &&
		          i < 4)
          {
			i++;
			//System.out.println("Valor de i: " + i);
	  	  }

          respTodas = lectorBuffer.readLine();
          for (int j = 0; j < 10; j++)
          {

		  		respCorrecta = arrayResp[i].leerElementoArray(j);
		  		//System.out.println("Respuesta correcta: " + respCorrecta);
		  		if (respTodas.charAt(j) == respCorrecta)
		  		{
					totalPuntos += 1;
				}
				else if (respTodas.charAt(j) == ' ')
				{
					totalPuntos -= 0.25;
				}
				else
				{
					totalPuntos -= 0.50;
				}
		  }

          if (totalPuntos >= 5.0)
          		flujoSalida.println("DNI: " + numeroDNI + "\t Puntos: " +
				                    totalPuntos+ "\t APTO" );
	  	  else
	  	   		flujoSalida.println("DNI: " + numeroDNI + "\t Puntos: " +
	  	  		                    totalPuntos+ "\t NO APTO" );

	  	  numeroDNI = lectorBuffer.readLine();
      }

      System.out.println("Fin - comprueba el fichero * resultados.txt *");

      //cerrar los ficheros
      lectorBuffer.close();
      flujoSalida.close();
  }
}

