import java.io.*;

/**
 *  Programa ArchivoRespuestasTest
 *
 *  Se trata de un programa que escribe objetos de la clase
 *  RespuestasTest en un fichero de salida denominado
 *  'respCorrectas.datos'
 *
 */

class ArchivoRespuestasTest
{
   public static void main (String[] args) throws IOException
   {
      //declarar y crear los flujos
      File               ficheroSalida      = new File( "respCorrectas.datos" );
      FileOutputStream   flujoSalidaFichero = new FileOutputStream( ficheroSalida );
      ObjectOutputStream flujoSalidaObjeto  = new ObjectOutputStream( flujoSalidaFichero );

      //declarar un array para cargarlo de datos y
      //declarar un objeto de la clase RespuestasTest
      char [] arrayRespuestas;
      RespuestasTest objetoResp;

      //crear y cargar el array con
      //las respuestas al test nmero 1
      arrayRespuestas = new char[10];
      arrayRespuestas [0] = 'A';
      arrayRespuestas [1] = 'C';
      arrayRespuestas [2] = 'E';
	  arrayRespuestas [3] = 'A';
      arrayRespuestas [4] = 'A';
      arrayRespuestas [5] = 'C';
      arrayRespuestas [6] = 'D';
      arrayRespuestas [7] = 'E';
      arrayRespuestas [8] = 'A';
	  arrayRespuestas [9] = 'A';

      //crear el objeto de la clase RespuestasTest,
	  objetoResp = new RespuestasTest();

      //almacenar la informacin en el objeto
      //y luego en el flujo
      objetoResp.escribirNumero (10);
      objetoResp.escribirArray (arrayRespuestas);
      flujoSalidaObjeto.writeObject (objetoResp);

      //crear y cargar el array con
      //las respuestas al test nmero 2
      arrayRespuestas = new char[10];
      arrayRespuestas [0] = 'A';
      arrayRespuestas [1] = 'B';
      arrayRespuestas [2] = 'B';
	  arrayRespuestas [3] = 'B';
      arrayRespuestas [4] = 'D';
      arrayRespuestas [5] = 'D';
      arrayRespuestas [6] = 'E';
      arrayRespuestas [7] = 'E';
      arrayRespuestas [8] = 'C';
	  arrayRespuestas [9] = 'A';
      objetoResp = new RespuestasTest();
      objetoResp.escribirNumero (20);
      objetoResp.escribirArray (arrayRespuestas);
      flujoSalidaObjeto.writeObject (objetoResp);

      //crear y cargar el array con
      //las respuestas al test nmero 3
      arrayRespuestas = new char [10];
      arrayRespuestas [0] = 'E';
      arrayRespuestas [1] = 'E';
      arrayRespuestas [2] = 'E';
	  arrayRespuestas [3] = 'A';
      arrayRespuestas [4] = 'E';
      arrayRespuestas [5] = 'D';
      arrayRespuestas [6] = 'E';
      arrayRespuestas [7] = 'A';
      arrayRespuestas [8] = 'B';
	  arrayRespuestas [9] = 'A';
      objetoResp = new RespuestasTest();
      objetoResp.escribirNumero (30);
	  objetoResp.escribirArray (arrayRespuestas);
	  flujoSalidaObjeto.writeObject (objetoResp);

      //crear y cargar el array con
      //las respuestas al test nmero 4
	  arrayRespuestas = new char [10];
	  arrayRespuestas [0] = 'C';
	  arrayRespuestas [1] = 'E';
	  arrayRespuestas [2] = 'B';
	  arrayRespuestas [3] = 'B';
	  arrayRespuestas [4] = 'C';
	  arrayRespuestas [5] = 'D';
	  arrayRespuestas [6] = 'A';
	  arrayRespuestas [7] = 'C';
	  arrayRespuestas [8] = 'C';
	  arrayRespuestas [9] = 'D';
	  objetoResp = new RespuestasTest();
	  objetoResp.escribirNumero (40);
	  objetoResp.escribirArray (arrayRespuestas);
	  flujoSalidaObjeto.writeObject (objetoResp);

      //cerrar el flujo
      flujoSalidaObjeto.close();

      System.out.println("Fin - comprobar el fichero * respCorrectas.datos *");
   }
}
